IF OBJECT_ID('dbo.Dates', 'U') IS NOT NULL DROP TABLE dbo.Dates;
CREATE TABLE dbo.Dates(
id INT IDENTITY NOT NULL PRIMARY KEY,
dt DATETIME NOT NULL
)
GO
 
-- Fill the table with 10M rows
DECLARE @number_of_rows INT = 10000000;
INSERT INTO dbo.Dates(dt)
SELECT  DATEADD(second,-ABS(CHECKSUM(NEWID())) % 314300000,'20131231') dt
FROM dbo.GetNums(@number_of_rows)
ORDER BY 1 ASC
GO

IF OBJECT_ID('dbo.Dates2014', 'U') IS NOT NULL DROP TABLE dbo.Dates2014;
CREATE TABLE dbo.Dates2014(
id INT IDENTITY NOT NULL PRIMARY KEY,
dt DATETIME NOT NULL
)
GO
DECLARE @number_of_rows INT = 1000000;
INSERT INTO dbo.Dates2014(dt)
SELECT DATEADD(second,-ABS(CHECKSUM(NEWID())) % 31400000,'20141231') dt
FROM dbo.GetNums(@number_of_rows)
ORDER BY 1 ASC
GO

IF OBJECT_ID('dbo.OrdersAsc', 'U') IS NOT NULL DROP TABLE dbo.OrdersAsc;
CREATE TABLE dbo.OrdersAsc(
id INT IDENTITY(1,1) NOT NULL,
custid INT NOT NULL,
orderdate DATETIME NOT NULL,
amount MONEY NOT NULL,
note CHAR(100) NOT NULL,
CONSTRAINT PK_OrdersAsc PRIMARY KEY CLUSTERED (id ASC)
)
GO
CREATE INDEX ix_orderdate ON OrdersAsc(orderdate)
GO
CREATE INDEX ix_custid ON OrdersAsc(custid)
GO

-- Fill the OrdersAsc table with 10M rows from 2004 to 2013
INSERT INTO dbo.OrdersAsc(custid,orderdate,amount, note)
SELECT 1 + ABS(CHECKSUM(NEWID())) % 100000 AS custid,
dt AS orderdate,
50 + ABS(CHECKSUM(NEWID())) % 1000 AS amount,
'note' AS note
FROM dbo.Dates
WHERE id < 5000000
ORDER BY id ASC
GO
UPDATE STATISTICS dbo.OrdersAsc ix_orderdate WITH FULLSCAN;
GO

INSERT INTO dbo.OrdersAsc(custid,orderdate,amount, note)
SELECT 1 + ABS(CHECKSUM(NEWID())) % 100000 AS custid,
dt AS orderdate,
50 + ABS(CHECKSUM(NEWID())) % 1000 AS amount,
'note' AS note
FROM dbo.Dates
WHERE id BETWEEN 5000000 AND 8000000
ORDER BY id ASC
GO
UPDATE STATISTICS dbo.OrdersAsc ix_orderdate WITH FULLSCAN;
GO

INSERT INTO dbo.OrdersAsc(custid,orderdate,amount, note)
SELECT 1 + ABS(CHECKSUM(NEWID())) % 100000 AS custid,
dt AS orderdate,
50 + ABS(CHECKSUM(NEWID())) % 1000 AS amount,
'note' AS note
FROM dbo.Dates
WHERE id BETWEEN 8000001 AND 9000000
ORDER BY id ASC
GO
UPDATE STATISTICS dbo.OrdersAsc ix_orderdate WITH FULLSCAN;
GO

INSERT INTO dbo.OrdersAsc(custid,orderdate,amount, note)
SELECT 1 + ABS(CHECKSUM(NEWID())) % 100000 AS custid,
dt AS orderdate,
50 + ABS(CHECKSUM(NEWID())) % 1000 AS amount,
'note' AS note
FROM dbo.Dates
WHERE id > 9000000
ORDER BY id ASC
GO
UPDATE STATISTICS dbo.OrdersAsc ix_orderdate WITH FULLSCAN;
GO
UPDATE STATISTICS dbo.OrdersAsc ix_custid WITH FULLSCAN;
GO

DBCC TRACEON(2388)
DBCC SHOW_STATISTICS ('OrdersAsc','ix_orderdate')
DBCC SHOW_STATISTICS ('OrdersAsc','ix_custid')
DBCC TRACEOFF(2388)
GO

--Fill the OrdersAsc table with 1M rows in 2014
INSERT INTO dbo.OrdersAsc(custid,orderdate,amount, note)
SELECT 1 + ABS(CHECKSUM(NEWID())) % 110000 AS custid,
dt AS orderdate,
50 + ABS(CHECKSUM(NEWID())) % 1000 AS amount,
'note' AS note
FROM dbo.Dates2014
ORDER BY id ASC
GO

--Query
SELECT * FROM dbo.OrdersAsc
WHERE custid = 160 AND orderdate >= '20140101' AND orderdate < '20150101' OPTION(QUERYTRACEON 2390, RECOMPILE);

SELECT * FROM dbo.OrdersAsc
WHERE custid = 160 AND orderdate >= '20140101' AND orderdate < '20150101' OPTION(QUERYTRACEON 2389, RECOMPILE);
